Index: drivers/filesystems/btrfs/write.c
===================================================================
--- drivers/filesystems/btrfs/write.c	(révision 75772)
+++ drivers/filesystems/btrfs/write.c	(copie de travail)
@@ -3971,7 +4212,7 @@
         } else
             tree_lock = TRUE;
     }
-        
+
     if (no_cache) {
         if (pagefile) {
             if (!ExAcquireResourceSharedLite(fcb->Header.Resource, wait)) {
@@ -3987,23 +4228,18 @@
                 fcb_lock = TRUE;
         }
     }
-    
+
     newlength = fcb->ads ? fcb->adsdata.Length : fcb->inode_item.st_size;
-    
+
     if (fcb->deleted)
         newlength = 0;
-    
+
     TRACE("newlength = %llx\n", newlength);
-    
-//     if (KeGetCurrentThread() == fcb->lazy_writer_thread) {
-//         ERR("lazy writer on the TV\n");
-//         lazy_writer = TRUE;
-//     }
-    
-    if (offset.QuadPart + *length > newlength) {
+
+    if (off64 + *length > newlength) {
         if (paging_io) {
-            if (offset.QuadPart >= newlength) {
-                TRACE("paging IO tried to write beyond end of file (file size = %llx, offset = %llx, length = %x)\n", newlength, offset.QuadPart, *length);
+            if (off64 >= newlength) {
+                TRACE("paging IO tried to write beyond end of file (file size = %llx, offset = %llx, length = %x)\n", newlength, off64, *length);
                 TRACE("filename %S\n", file_desc(FileObject));
                 TRACE("FileObject: AllocationSize = %llx, FileSize = %llx, ValidDataLength = %llx\n",
                     fcb->Header.AllocationSize.QuadPart, fcb->Header.FileSize.QuadPart, fcb->Header.ValidDataLength.QuadPart);
@@ -4010,23 +4246,28 @@
                 Status = STATUS_SUCCESS;
                 goto end;
             }
-            
-            *length = newlength - offset.QuadPart;
+
+            *length = (ULONG)(newlength - off64);
         } else {
-            newlength = offset.QuadPart + *length;
+            newlength = off64 + *length;
             changed_length = TRUE;
-            
+
             TRACE("extending length to %llx\n", newlength);
         }
     }
-    
-    make_inline = fcb->ads ? FALSE : newlength <= fcb->Vcb->options.max_inline;
-    
+
+    if (fcb->ads)
+        make_inline = FALSE;
+    else if (fcb->type == BTRFS_TYPE_SYMLINK)
+        make_inline = newlength <= (Vcb->superblock.node_size - sizeof(tree_header) - sizeof(leaf_node) - offsetof(EXTENT_DATA, data[0]));
+    else
+        make_inline = newlength <= fcb->Vcb->options.max_inline;
+
     if (changed_length) {
-        if (newlength > fcb->Header.AllocationSize.QuadPart) {
+        if (newlength > (UINT64)fcb->Header.AllocationSize.QuadPart) {
             if (!tree_lock) {
-                // We need to acquire the tree lock if we don't have it already - 
-                // we can't give an inline file proper extents at the same as we're
+                // We need to acquire the tree lock if we don't have it already -
+                // we can't give an inline file proper extents at the same time as we're
                 // doing a flush.
                 if (!ExAcquireResourceSharedLite(&Vcb->tree_lock, wait)) {
                     Status = STATUS_PENDING;
@@ -4034,7 +4275,7 @@
                 } else
                     tree_lock = TRUE;
             }
-            
+
             Status = extend_file(fcb, fileref, newlength, FALSE, Irp, rollback);
             if (!NT_SUCCESS(Status)) {
                 ERR("extend_file returned %08x\n", Status);
@@ -4042,60 +4283,65 @@
             }
         } else if (!fcb->ads)
             fcb->inode_item.st_size = newlength;
-        
+
         fcb->Header.FileSize.QuadPart = newlength;
         fcb->Header.ValidDataLength.QuadPart = newlength;
-        
+
         TRACE("AllocationSize = %llx\n", fcb->Header.AllocationSize.QuadPart);
         TRACE("FileSize = %llx\n", fcb->Header.FileSize.QuadPart);
         TRACE("ValidDataLength = %llx\n", fcb->Header.ValidDataLength.QuadPart);
     }
-    
+
     if (!no_cache) {
-        if (!FileObject->PrivateCacheMap || changed_length) {
-            CC_FILE_SIZES ccfs;
-            
-            ccfs.AllocationSize = fcb->Header.AllocationSize;
-            ccfs.FileSize = fcb->Header.FileSize;
-            ccfs.ValidDataLength = fcb->Header.ValidDataLength;
-            
-            if (!FileObject->PrivateCacheMap)
-                init_file_cache(FileObject, &ccfs);
-            
-            CcSetFileSizes(FileObject, &ccfs);
-        }
-        
-        if (IrpSp->MinorFunction & IRP_MN_MDL) {
-            CcPrepareMdlWrite(FileObject, &offset, *length, &Irp->MdlAddress, &Irp->IoStatus);
+        Status = STATUS_SUCCESS;
 
-            Status = Irp->IoStatus.Status;
-            goto end;
-        } else {
-            if (CcCopyWriteEx) {
-                TRACE("CcCopyWriteEx(%p, %llx, %x, %u, %p, %p)\n", FileObject, offset.QuadPart, *length, wait, buf, Irp->Tail.Overlay.Thread);
-                if (!CcCopyWriteEx(FileObject, &offset, *length, wait, buf, Irp->Tail.Overlay.Thread)) {
-                    Status = STATUS_PENDING;
-                    goto end;
-                }
-                TRACE("CcCopyWriteEx finished\n");
+        _SEH2_TRY {
+            if (!FileObject->PrivateCacheMap || changed_length) {
+                CC_FILE_SIZES ccfs;
+
+                ccfs.AllocationSize = fcb->Header.AllocationSize;
+                ccfs.FileSize = fcb->Header.FileSize;
+                ccfs.ValidDataLength = fcb->Header.ValidDataLength;
+
+                if (!FileObject->PrivateCacheMap)
+                    init_file_cache(FileObject, &ccfs);
+
+                CcSetFileSizes(FileObject, &ccfs);
+            }
+
+            if (IrpSp->MinorFunction & IRP_MN_MDL) {
+                CcPrepareMdlWrite(FileObject, &offset, *length, &Irp->MdlAddress, &Irp->IoStatus);
+
+                Status = Irp->IoStatus.Status;
+                goto end;
             } else {
-                TRACE("CcCopyWrite(%p, %llx, %x, %u, %p)\n", FileObject, offset.QuadPart, *length, wait, buf);
-                if (!CcCopyWrite(FileObject, &offset, *length, wait, buf)) {
-                    Status = STATUS_PENDING;
-                    goto end;
+                if (fCcCopyWriteEx) {
+                    TRACE("CcCopyWriteEx(%p, %llx, %x, %u, %p, %p)\n", FileObject, off64, *length, wait, buf, Irp->Tail.Overlay.Thread);
+                    if (!fCcCopyWriteEx(FileObject, &offset, *length, wait, buf, Irp->Tail.Overlay.Thread)) {
+                        Status = STATUS_PENDING;
+                        goto end;
+                    }
+                    TRACE("CcCopyWriteEx finished\n");
+                } else {
+                    TRACE("CcCopyWrite(%p, %llx, %x, %u, %p)\n", FileObject, off64, *length, wait, buf);
+                    if (!CcCopyWrite(FileObject, &offset, *length, wait, buf)) {
+                        Status = STATUS_PENDING;
+                        goto end;
+                    }
+                    TRACE("CcCopyWrite finished\n");
                 }
-                TRACE("CcCopyWrite finished\n");
             }
-        }
-        
-        Status = STATUS_SUCCESS;
+        } _SEH2_EXCEPT (EXCEPTION_EXECUTE_HANDLER) {
+            Status = _SEH2_GetExceptionCode();
+        } _SEH2_END;
+
         goto end;
     }
-    
+
     if (fcb->ads) {
         if (changed_length) {
             char* data2;
-            
+
             if (newlength > fcb->adsmaxlen) {
                 ERR("error - xattr too long (%llu > %u)\n", newlength, fcb->adsmaxlen);
                 Status = STATUS_DISK_FULL;
@@ -4102,90 +4348,98 @@
                 goto end;
             }
 
-            data2 = ExAllocatePoolWithTag(PagedPool, newlength, ALLOC_TAG);
+            data2 = ExAllocatePoolWithTag(PagedPool, (ULONG)newlength, ALLOC_TAG);
             if (!data2) {
                 ERR("out of memory\n");
                 Status = STATUS_INSUFFICIENT_RESOURCES;
                 goto end;
             }
-            
+
             if (fcb->adsdata.Buffer) {
                 RtlCopyMemory(data2, fcb->adsdata.Buffer, fcb->adsdata.Length);
                 ExFreePool(fcb->adsdata.Buffer);
             }
-            
+
             if (newlength > fcb->adsdata.Length)
-                RtlZeroMemory(&data2[fcb->adsdata.Length], newlength - fcb->adsdata.Length);
-            
-            
+                RtlZeroMemory(&data2[fcb->adsdata.Length], (ULONG)(newlength - fcb->adsdata.Length));
+
+
             fcb->adsdata.Buffer = data2;
-            fcb->adsdata.Length = fcb->adsdata.MaximumLength = newlength;
-            
+            fcb->adsdata.Length = fcb->adsdata.MaximumLength = (USHORT)newlength;
+
             fcb->Header.AllocationSize.QuadPart = newlength;
             fcb->Header.FileSize.QuadPart = newlength;
             fcb->Header.ValidDataLength.QuadPart = newlength;
         }
-        
+
         if (*length > 0)
-            RtlCopyMemory(&fcb->adsdata.Buffer[offset.QuadPart], buf, *length);
-        
+            RtlCopyMemory(&fcb->adsdata.Buffer[off64], buf, *length);
+
         fcb->Header.ValidDataLength.QuadPart = newlength;
-        
+
         mark_fcb_dirty(fcb);
-        
+
         if (fileref)
             mark_fileref_dirty(fileref);
     } else {
-        BOOL compress = write_fcb_compressed(fcb);
-        
+        BOOL compress = write_fcb_compressed(fcb), no_buf = FALSE;
+
         if (make_inline) {
             start_data = 0;
             end_data = sector_align(newlength, fcb->Vcb->superblock.sector_size);
             bufhead = sizeof(EXTENT_DATA) - 1;
         } else if (compress) {
-            start_data = offset.QuadPart & ~(UINT64)(COMPRESSED_EXTENT_SIZE - 1);
-            end_data = min(sector_align(offset.QuadPart + *length, COMPRESSED_EXTENT_SIZE),
+            start_data = off64 & ~(UINT64)(COMPRESSED_EXTENT_SIZE - 1);
+            end_data = min(sector_align(off64 + *length, COMPRESSED_EXTENT_SIZE),
                            sector_align(newlength, fcb->Vcb->superblock.sector_size));
             bufhead = 0;
         } else {
-            start_data = offset.QuadPart & ~(UINT64)(fcb->Vcb->superblock.sector_size - 1);
-            end_data = sector_align(offset.QuadPart + *length, fcb->Vcb->superblock.sector_size);
+            start_data = off64 & ~(UINT64)(fcb->Vcb->superblock.sector_size - 1);
+            end_data = sector_align(off64 + *length, fcb->Vcb->superblock.sector_size);
             bufhead = 0;
         }
-            
+
+        if (fcb_is_inline(fcb))
+            end_data = max(end_data, sector_align(fcb->inode_item.st_size, Vcb->superblock.sector_size));
+
         fcb->Header.ValidDataLength.QuadPart = newlength;
         TRACE("fcb %p FileSize = %llx\n", fcb, fcb->Header.FileSize.QuadPart);
-    
-        data = ExAllocatePoolWithTag(PagedPool, end_data - start_data + bufhead, ALLOC_TAG);
-        if (!data) {
-            ERR("out of memory\n");
-            Status = STATUS_INSUFFICIENT_RESOURCES;
-            goto end;
-        }
-        
-        RtlZeroMemory(data + bufhead, end_data - start_data);
-        
-        TRACE("start_data = %llx\n", start_data);
-        TRACE("end_data = %llx\n", end_data);
-        
-        if (offset.QuadPart > start_data || offset.QuadPart + *length < end_data) {
-            if (changed_length) {
-                if (fcb->inode_item.st_size > start_data) 
-                    Status = read_file(fcb, data + bufhead, start_data, fcb->inode_item.st_size - start_data, NULL, Irp, TRUE);
-                else
-                    Status = STATUS_SUCCESS;
-            } else
-                Status = read_file(fcb, data + bufhead, start_data, end_data - start_data, NULL, Irp, TRUE);
-            
-            if (!NT_SUCCESS(Status)) {
-                ERR("read_file returned %08x\n", Status);
-                ExFreePool(data);
+
+        if (!make_inline && !compress && off64 == start_data && off64 + *length == end_data) {
+            data = buf;
+            no_buf = TRUE;
+        } else {
+            data = ExAllocatePoolWithTag(PagedPool, (ULONG)(end_data - start_data + bufhead), ALLOC_TAG);
+            if (!data) {
+                ERR("out of memory\n");
+                Status = STATUS_INSUFFICIENT_RESOURCES;
                 goto end;
             }
+
+            RtlZeroMemory(data + bufhead, (ULONG)(end_data - start_data));
+
+            TRACE("start_data = %llx\n", start_data);
+            TRACE("end_data = %llx\n", end_data);
+
+            if (off64 > start_data || off64 + *length < end_data) {
+                if (changed_length) {
+                    if (fcb->inode_item.st_size > start_data)
+                        Status = read_file(fcb, data + bufhead, start_data, fcb->inode_item.st_size - start_data, NULL, Irp);
+                    else
+                        Status = STATUS_SUCCESS;
+                } else
+                    Status = read_file(fcb, data + bufhead, start_data, end_data - start_data, NULL, Irp);
+
+                if (!NT_SUCCESS(Status)) {
+                    ERR("read_file returned %08x\n", Status);
+                    ExFreePool(data);
+                    goto end;
+                }
+            }
+
+            RtlCopyMemory(data + bufhead + off64 - start_data, buf, *length);
         }
-        
-        RtlCopyMemory(data + bufhead + offset.QuadPart - start_data, buf, *length);
-        
+
         if (make_inline) {
             Status = excise_extents(fcb->Vcb, fcb, start_data, end_data, Irp, rollback);
             if (!NT_SUCCESS(Status)) {
@@ -4193,7 +4447,7 @@
                 ExFreePool(data);
                 goto end;
             }
-            
+
             ed2 = (EXTENT_DATA*)data;
             ed2->generation = fcb->Vcb->superblock.generation;
             ed2->decoded_size = newlength;
@@ -4201,59 +4455,75 @@
             ed2->encryption = BTRFS_ENCRYPTION_NONE;
             ed2->encoding = BTRFS_ENCODING_NONE;
             ed2->type = EXTENT_TYPE_INLINE;
-            
-            if (!add_extent_to_fcb(fcb, 0, ed2, sizeof(EXTENT_DATA) - 1 + newlength, FALSE, NULL, rollback)) {
-                ERR("add_extent_to_fcb failed\n");
+
+            Status = add_extent_to_fcb(fcb, 0, ed2, (UINT16)(offsetof(EXTENT_DATA, data[0]) + newlength), FALSE, NULL, rollback);
+            if (!NT_SUCCESS(Status)) {
+                ERR("add_extent_to_fcb returned %08x\n", Status);
                 ExFreePool(data);
-                Status = STATUS_INTERNAL_ERROR;
                 goto end;
             }
-            
+
             fcb->inode_item.st_blocks += newlength;
         } else if (compress) {
             Status = write_compressed(fcb, start_data, end_data, data, Irp, rollback);
-            
+
             if (!NT_SUCCESS(Status)) {
                 ERR("write_compressed returned %08x\n", Status);
                 ExFreePool(data);
                 goto end;
             }
-            
+
             ExFreePool(data);
         } else {
-            Status = do_write_file(fcb, start_data, end_data, data, Irp, rollback);
-            
+            if (write_irp && Irp->MdlAddress && no_buf) {
+                BOOL locked = Irp->MdlAddress->MdlFlags & MDL_PAGES_LOCKED;
+
+                if (!locked) {
+                    Status = STATUS_SUCCESS;
+
+                    _SEH2_TRY {
+                        MmProbeAndLockPages(Irp->MdlAddress, KernelMode, IoReadAccess);
+                    } _SEH2_EXCEPT (EXCEPTION_EXECUTE_HANDLER) {
+                        Status = _SEH2_GetExceptionCode();
+                    } _SEH2_END;
+
+                    if (!NT_SUCCESS(Status)) {
+                        ERR("MmProbeAndLockPages threw exception %08x\n", Status);
+                        goto end;
+                    }
+                }
+
+                _SEH2_TRY {
+                    Status = do_write_file(fcb, start_data, end_data, data, Irp, TRUE, 0, rollback);
+                } _SEH2_EXCEPT (EXCEPTION_EXECUTE_HANDLER) {
+                    Status = _SEH2_GetExceptionCode();
+                } _SEH2_END;
+
+                if (!locked)
+                    MmUnlockPages(Irp->MdlAddress);
+            } else {
+                _SEH2_TRY {
+                    Status = do_write_file(fcb, start_data, end_data, data, Irp, FALSE, 0, rollback);
+                } _SEH2_EXCEPT (EXCEPTION_EXECUTE_HANDLER) {
+                    Status = _SEH2_GetExceptionCode();
+                } _SEH2_END;
+            }
+
             if (!NT_SUCCESS(Status)) {
                 ERR("do_write_file returned %08x\n", Status);
-                ExFreePool(data);
+                if (!no_buf) ExFreePool(data);
                 goto end;
             }
-            
-            ExFreePool(data);
+
+            if (!no_buf)
+                ExFreePool(data);
         }
     }
-    
+
+    KeQuerySystemTime(&time);
+    win_time_to_unix(time, &now);
+
     if (!pagefile) {
-        KeQuerySystemTime(&time);
-        win_time_to_unix(time, &now);
-    
-//         ERR("no_cache = %s, FileObject->PrivateCacheMap = %p\n", no_cache ? "TRUE" : "FALSE", FileObject->PrivateCacheMap);
-//         
-//         if (!no_cache) {
-//             if (!FileObject->PrivateCacheMap) {
-//                 CC_FILE_SIZES ccfs;
-//                 
-//                 ccfs.AllocationSize = fcb->Header.AllocationSize;
-//                 ccfs.FileSize = fcb->Header.FileSize;
-//                 ccfs.ValidDataLength = fcb->Header.ValidDataLength;
-//                 
-//                 TRACE("calling CcInitializeCacheMap...\n");
-//                 CcInitializeCacheMap(FileObject, &ccfs, FALSE, cache_callbacks, fcb);
-//                 
-//                 changed_length = FALSE;
-//             }
-//         }
-        
         if (fcb->ads) {
             if (fileref && fileref->parent)
                 origii = &fileref->parent->fcb->inode_item;
@@ -4264,13 +4534,13 @@
             }
         } else
             origii = &fcb->inode_item;
-        
+
         origii->transid = Vcb->superblock.generation;
         origii->sequence++;
-        
+
         if (!ccb->user_set_change_time)
             origii->st_ctime = now;
-        
+
         if (!fcb->ads) {
             if (changed_length) {
                 TRACE("setting st_size to %llx\n", newlength);
@@ -4277,44 +4547,46 @@
                 origii->st_size = newlength;
                 filter |= FILE_NOTIFY_CHANGE_SIZE;
             }
-            
-            if (!ccb->user_set_write_time) {
-                origii->st_mtime = now;
-                filter |= FILE_NOTIFY_CHANGE_LAST_WRITE;
-            }
-            
+
             fcb->inode_item_changed = TRUE;
-        } else
+        } else {
             fileref->parent->fcb->inode_item_changed = TRUE;
-        
+
+            if (changed_length)
+                filter |= FILE_NOTIFY_CHANGE_SIZE;
+        }
+
+        if (!ccb->user_set_write_time) {
+            origii->st_mtime = now;
+            filter |= FILE_NOTIFY_CHANGE_LAST_WRITE;
+        }
+
         mark_fcb_dirty(fcb->ads ? fileref->parent->fcb : fcb);
     }
-    
+
     if (changed_length) {
         CC_FILE_SIZES ccfs;
-            
+
         ccfs.AllocationSize = fcb->Header.AllocationSize;
         ccfs.FileSize = fcb->Header.FileSize;
         ccfs.ValidDataLength = fcb->Header.ValidDataLength;
 
-        CcSetFileSizes(FileObject, &ccfs);
+        _SEH2_TRY {
+            CcSetFileSizes(FileObject, &ccfs);
+        } _SEH2_EXCEPT (EXCEPTION_EXECUTE_HANDLER) {
+            Status = _SEH2_GetExceptionCode();
+            goto end;
+        } _SEH2_END;
     }
-    
-    // FIXME - make sure this still called if STATUS_PENDING and async
-//     if (!no_cache) {
-//         if (!CcCopyWrite(FileObject, &offset, *length, TRUE, buf)) {
-//             ERR("CcCopyWrite failed.\n");
-//         }
-//     }
-    
+
     fcb->subvol->root_item.ctransid = Vcb->superblock.generation;
     fcb->subvol->root_item.ctime = now;
-    
+
     Status = STATUS_SUCCESS;
-    
+
     if (filter != 0)
-        send_notification_fcb(fcb->ads ? fileref->parent : fileref, filter, FILE_ACTION_MODIFIED);
-    
+        send_notification_fcb(fcb->ads ? fileref->parent : fileref, filter, FILE_ACTION_MODIFIED, fcb->ads && fileref->dc ? &fileref->dc->name : NULL);
+
 end:
     if (NT_SUCCESS(Status) && FileObject->Flags & FO_SYNCHRONOUS_IO && !paging_io) {
         TRACE("CurrentByteOffset was: %llx\n", FileObject->CurrentByteOffset.QuadPart);
@@ -4321,13 +4593,13 @@
         FileObject->CurrentByteOffset.QuadPart = offset.QuadPart + (NT_SUCCESS(Status) ? *length : 0);
         TRACE("CurrentByteOffset now: %llx\n", FileObject->CurrentByteOffset.QuadPart);
     }
-    
+
     if (fcb_lock)
         ExReleaseResourceLite(fcb->Header.Resource);
-    
+
     if (tree_lock)
         ExReleaseResourceLite(&Vcb->tree_lock);
-    
+
     if (paging_lock)
         ExReleaseResourceLite(fcb->Header.PagingIoResource);
 
@@ -4334,7 +4606,7 @@
     return Status;
 }
 
-NTSTATUS write_file(device_extension* Vcb, PIRP Irp, BOOL wait, BOOL deferred_write) {
+NTSTATUS write_file(device_extension* Vcb, PIRP Irp, BOOLEAN wait, BOOLEAN deferred_write) {
     PIO_STACK_LOCATION IrpSp = IoGetCurrentIrpStackLocation(Irp);
     void* buf;
     NTSTATUS Status;
@@ -4341,52 +4613,39 @@
     LARGE_INTEGER offset = IrpSp->Parameters.Write.ByteOffset;
     PFILE_OBJECT FileObject = IrpSp->FileObject;
     fcb* fcb = FileObject ? FileObject->FsContext : NULL;
-//     BOOL locked = FALSE;
-//     LARGE_INTEGER freq, time1, time2;
     LIST_ENTRY rollback;
-    
+
     InitializeListHead(&rollback);
-    
-//     time1 = KeQueryPerformanceCounter(&freq);
-    
+
     TRACE("write\n");
-    
+
     Irp->IoStatus.Information = 0;
-    
+
     TRACE("offset = %llx\n", offset.QuadPart);
     TRACE("length = %x\n", IrpSp->Parameters.Write.Length);
-    
+
     if (!Irp->AssociatedIrp.SystemBuffer) {
-        buf = map_user_buffer(Irp);
-        
+        buf = map_user_buffer(Irp, fcb && fcb->Header.Flags2 & FSRTL_FLAG2_IS_PAGING_FILE ? HighPagePriority : NormalPagePriority);
+
         if (Irp->MdlAddress && !buf) {
             ERR("MmGetSystemAddressForMdlSafe returned NULL\n");
             Status = STATUS_INSUFFICIENT_RESOURCES;
             goto exit;
-        }   
+        }
     } else
         buf = Irp->AssociatedIrp.SystemBuffer;
-    
+
     TRACE("buf = %p\n", buf);
-    
-//     if (Irp->Flags & IRP_NOCACHE) {
-//         if (!ExAcquireResourceSharedLite(&Vcb->tree_lock, wait)) {
-//             Status = STATUS_PENDING;
-//             goto exit;
-//         }
-//         locked = TRUE;
-//     }
-    
+
     if (fcb && !(Irp->Flags & IRP_PAGING_IO) && !FsRtlCheckLockForWriteAccess(&fcb->lock, Irp)) {
         WARN("tried to write to locked region\n");
         Status = STATUS_FILE_LOCK_CONFLICT;
         goto exit;
     }
-    
-//     ERR("Irp->Flags = %x\n", Irp->Flags);
+
     Status = write_file2(Vcb, Irp, offset, buf, &IrpSp->Parameters.Write.Length, Irp->Flags & IRP_PAGING_IO, Irp->Flags & IRP_NOCACHE,
-                         wait, deferred_write, &rollback);
-    
+                         wait, deferred_write, TRUE, &rollback);
+
     if (Status == STATUS_PENDING)
         goto exit;
     else if (!NT_SUCCESS(Status)) {
@@ -4393,23 +4652,13 @@
         ERR("write_file2 returned %08x\n", Status);
         goto exit;
     }
-    
-//     if (locked)
-//         Status = consider_write(Vcb);
 
     if (NT_SUCCESS(Status)) {
         Irp->IoStatus.Information = IrpSp->Parameters.Write.Length;
-    
-#ifdef DEBUG_PARANOID
-//         if (locked)
-//             check_extents_consistent(Vcb, FileObject->FsContext); // TESTING
-    
-//         check_extent_tree_consistent(Vcb);
-#endif
-        
+
         if (diskacc && Status != STATUS_PENDING && Irp->Flags & IRP_NOCACHE) {
             PETHREAD thread = NULL;
-            
+
             if (Irp->Tail.Overlay.Thread && !IoIsSystemThread(Irp->Tail.Overlay.Thread))
                 thread = Irp->Tail.Overlay.Thread;
             else if (!IoIsSystemThread(PsGetCurrentThread()))
@@ -4416,30 +4665,24 @@
                 thread = PsGetCurrentThread();
             else if (IoIsSystemThread(PsGetCurrentThread()) && IoGetTopLevelIrp() == Irp)
                 thread = PsGetCurrentThread();
-            
+
             if (thread)
-                PsUpdateDiskCounters(PsGetThreadProcess(thread), 0, IrpSp->Parameters.Write.Length, 0, 1, 0);
+                fPsUpdateDiskCounters(PsGetThreadProcess(thread), 0, IrpSp->Parameters.Write.Length, 0, 1, 0);
         }
     }
-    
+
 exit:
-//     if (locked) {
-        if (NT_SUCCESS(Status))
-            clear_rollback(Vcb, &rollback);
-        else
-            do_rollback(Vcb, &rollback);
-//         
-//         ExReleaseResourceLite(&Vcb->tree_lock);
-//     }
-    
-//     time2 = KeQueryPerformanceCounter(NULL);
-    
-//     ERR("time = %u (freq = %u)\n", (UINT32)(time2.QuadPart - time1.QuadPart), (UINT32)freq.QuadPart);
-    
+    if (NT_SUCCESS(Status))
+        clear_rollback(&rollback);
+    else
+        do_rollback(Vcb, &rollback);
+
     return Status;
 }
 
-NTSTATUS STDCALL drv_write(IN PDEVICE_OBJECT DeviceObject, IN PIRP Irp) {
+_Dispatch_type_(IRP_MJ_WRITE)
+_Function_class_(DRIVER_DISPATCH)
+NTSTATUS drv_write(IN PDEVICE_OBJECT DeviceObject, IN PIRP Irp) {
     NTSTATUS Status;
     BOOL top_level;
     PIO_STACK_LOCATION IrpSp = IoGetCurrentIrpStackLocation(Irp);
@@ -4447,35 +4690,38 @@
     PFILE_OBJECT FileObject = IrpSp->FileObject;
     fcb* fcb = FileObject ? FileObject->FsContext : NULL;
     ccb* ccb = FileObject ? FileObject->FsContext2 : NULL;
-    BOOL wait = FileObject ? IoIsOperationSynchronous(Irp) : TRUE;
+    BOOLEAN wait = FileObject ? IoIsOperationSynchronous(Irp) : TRUE;
 
     FsRtlEnterFileSystem();
 
     top_level = is_top_level(Irp);
-    
-    if (Vcb && Vcb->type == VCB_TYPE_PARTITION0) {
-        Status = part0_passthrough(DeviceObject, Irp);
+
+    if (Vcb && Vcb->type == VCB_TYPE_VOLUME) {
+        Status = vol_write(DeviceObject, Irp);
         goto exit;
+    } else if (!Vcb || Vcb->type != VCB_TYPE_FS) {
+        Status = STATUS_INVALID_PARAMETER;
+        goto end;
     }
-    
+
     if (!fcb) {
         ERR("fcb was NULL\n");
         Status = STATUS_INVALID_PARAMETER;
         goto end;
     }
-    
+
     if (!ccb) {
         ERR("ccb was NULL\n");
         Status = STATUS_INVALID_PARAMETER;
         goto end;
     }
-    
+
     if (Irp->RequestorMode == UserMode && !(ccb->access & (FILE_WRITE_DATA | FILE_APPEND_DATA))) {
         WARN("insufficient permissions\n");
         Status = STATUS_ACCESS_DENIED;
         goto end;
     }
-    
+
     if (fcb == Vcb->volume_fcb) {
         if (!Vcb->locked || Vcb->locked_fileobj != FileObject) {
             ERR("trying to write to volume when not locked, or locked with another FileObject\n");
@@ -4482,31 +4728,29 @@
             Status = STATUS_ACCESS_DENIED;
             goto end;
         }
-        
+
         TRACE("writing directly to volume\n");
-        
+
         IoSkipCurrentIrpStackLocation(Irp);
-    
+
         Status = IoCallDriver(Vcb->Vpb->RealDevice, Irp);
         goto exit;
     }
-    
-    if (fcb->subvol->root_item.flags & BTRFS_SUBVOL_READONLY) {
+
+    if (is_subvol_readonly(fcb->subvol, Irp)) {
         Status = STATUS_ACCESS_DENIED;
         goto end;
     }
-    
+
     if (Vcb->readonly) {
         Status = STATUS_MEDIA_WRITE_PROTECTED;
         goto end;
     }
-    
-//     ERR("recursive = %s\n", Irp != IoGetTopLevelIrp() ? "TRUE" : "FALSE");
-    
+
     _SEH2_TRY {
         if (IrpSp->MinorFunction & IRP_MN_COMPLETE) {
             CcMdlWriteComplete(IrpSp->FileObject, &IrpSp->Parameters.Write.ByteOffset, Irp->MdlAddress);
-            
+
             Irp->MdlAddress = NULL;
             Status = STATUS_SUCCESS;
         } else {
@@ -4514,34 +4758,34 @@
             // deadlocks in CcCopyWrite.
             if (Irp->Flags & IRP_PAGING_IO)
                 wait = TRUE;
-            
+
             Status = write_file(Vcb, Irp, wait, FALSE);
         }
     } _SEH2_EXCEPT (EXCEPTION_EXECUTE_HANDLER) {
         Status = _SEH2_GetExceptionCode();
     } _SEH2_END;
-    
+
 end:
     Irp->IoStatus.Status = Status;
 
     TRACE("wrote %u bytes\n", Irp->IoStatus.Information);
-    
+
     if (Status != STATUS_PENDING)
         IoCompleteRequest(Irp, IO_NO_INCREMENT);
     else {
         IoMarkIrpPending(Irp);
-        
+
         if (!add_thread_job(Vcb, Irp))
             do_write_job(Vcb, Irp);
     }
-    
+
 exit:
-    if (top_level) 
+    if (top_level)
         IoSetTopLevelIrp(NULL);
-    
-    FsRtlExitFileSystem();
-    
+
     TRACE("returning %08x\n", Status);
 
+    FsRtlExitFileSystem();
+
     return Status;
 }
